=== modified file 'drizzled/function/time/dayofmonth.cc'
--- drizzled/function/time/dayofmonth.cc	2009-01-29 20:12:20 +0000
+++ drizzled/function/time/dayofmonth.cc	2009-01-30 04:01:12 +0000
@@ -40,6 +40,15 @@
   
   switch (arg0_result_type)
   {
+    case DECIMAL_RESULT: 
+      /* 
+       * For doubles supplied, interpret the arg as a string, 
+       * so intentionally fall-through here...
+       * This allows us to accept double parameters like 
+       * 19971231235959.01 and interpret it the way MySQL does:
+       * as a TIMESTAMP-like thing with a microsecond component.
+       * Ugh, but need to keep backwards-compat.
+       */
     case STRING_RESULT:
       {
         char buff[DRIZZLE_MAX_LENGTH_DATETIME_AS_STRING];

=== modified file 'drizzled/function/time/dayofyear.cc'
--- drizzled/function/time/dayofyear.cc	2009-01-29 20:12:20 +0000
+++ drizzled/function/time/dayofyear.cc	2009-01-30 04:01:12 +0000
@@ -41,6 +41,15 @@
   
   switch (arg0_result_type)
   {
+    case DECIMAL_RESULT: 
+      /* 
+       * For doubles supplied, interpret the arg as a string, 
+       * so intentionally fall-through here...
+       * This allows us to accept double parameters like 
+       * 19971231235959.01 and interpret it the way MySQL does:
+       * as a TIMESTAMP-like thing with a microsecond component.
+       * Ugh, but need to keep backwards-compat.
+       */
     case STRING_RESULT:
       {
         char buff[DRIZZLE_MAX_LENGTH_DATETIME_AS_STRING];

=== modified file 'drizzled/function/time/hour.cc'
--- drizzled/function/time/hour.cc	2009-01-29 21:31:20 +0000
+++ drizzled/function/time/hour.cc	2009-01-30 04:01:12 +0000
@@ -66,6 +66,15 @@
     
     switch (arg0_result_type)
     {
+      case DECIMAL_RESULT: 
+        /* 
+         * For doubles supplied, interpret the arg as a string, 
+         * so intentionally fall-through here...
+         * This allows us to accept double parameters like 
+         * 19971231235959.01 and interpret it the way MySQL does:
+         * as a TIMESTAMP-like thing with a microsecond component.
+         * Ugh, but need to keep backwards-compat.
+         */
       case STRING_RESULT:
         {
           char buff[DRIZZLE_MAX_LENGTH_DATETIME_AS_STRING];

=== modified file 'drizzled/function/time/microsecond.cc'
--- drizzled/function/time/microsecond.cc	2009-01-29 22:00:06 +0000
+++ drizzled/function/time/microsecond.cc	2009-01-30 04:01:12 +0000
@@ -66,6 +66,15 @@
     
     switch (arg0_result_type)
     {
+      case DECIMAL_RESULT: 
+        /* 
+         * For doubles supplied, interpret the arg as a string, 
+         * so intentionally fall-through here...
+         * This allows us to accept double parameters like 
+         * 19971231235959.01 and interpret it the way MySQL does:
+         * as a TIMESTAMP-like thing with a microsecond component.
+         * Ugh, but need to keep backwards-compat.
+         */
       case STRING_RESULT:
         {
           char buff[DRIZZLE_MAX_LENGTH_DATETIME_AS_STRING];

=== modified file 'drizzled/function/time/minute.cc'
--- drizzled/function/time/minute.cc	2009-01-29 21:40:38 +0000
+++ drizzled/function/time/minute.cc	2009-01-30 04:01:12 +0000
@@ -66,6 +66,15 @@
     
     switch (arg0_result_type)
     {
+      case DECIMAL_RESULT: 
+        /* 
+         * For doubles supplied, interpret the arg as a string, 
+         * so intentionally fall-through here...
+         * This allows us to accept double parameters like 
+         * 19971231235959.01 and interpret it the way MySQL does:
+         * as a TIMESTAMP-like thing with a microsecond component.
+         * Ugh, but need to keep backwards-compat.
+         */
       case STRING_RESULT:
         {
           char buff[DRIZZLE_MAX_LENGTH_DATETIME_AS_STRING];

=== modified file 'drizzled/function/time/month.cc'
--- drizzled/function/time/month.cc	2009-01-29 20:12:20 +0000
+++ drizzled/function/time/month.cc	2009-01-30 04:01:12 +0000
@@ -41,6 +41,15 @@
   
   switch (arg0_result_type)
   {
+    case DECIMAL_RESULT: 
+      /* 
+       * For doubles supplied, interpret the arg as a string, 
+       * so intentionally fall-through here...
+       * This allows us to accept double parameters like 
+       * 19971231235959.01 and interpret it the way MySQL does:
+       * as a TIMESTAMP-like thing with a microsecond component.
+       * Ugh, but need to keep backwards-compat.
+       */
     case STRING_RESULT:
       {
         char buff[DRIZZLE_MAX_LENGTH_DATETIME_AS_STRING];

=== modified file 'drizzled/function/time/second.cc'
--- drizzled/function/time/second.cc	2009-01-29 20:12:20 +0000
+++ drizzled/function/time/second.cc	2009-01-30 04:01:12 +0000
@@ -66,6 +66,15 @@
     
     switch (arg0_result_type)
     {
+      case DECIMAL_RESULT: 
+        /* 
+         * For doubles supplied, interpret the arg as a string, 
+         * so intentionally fall-through here...
+         * This allows us to accept double parameters like 
+         * 19971231235959.01 and interpret it the way MySQL does:
+         * as a TIMESTAMP-like thing with a microsecond component.
+         * Ugh, but need to keep backwards-compat.
+         */
       case STRING_RESULT:
         {
           char buff[DRIZZLE_MAX_LENGTH_DATETIME_AS_STRING];

=== modified file 'drizzled/function/time/year.cc'
--- drizzled/function/time/year.cc	2009-01-29 19:47:12 +0000
+++ drizzled/function/time/year.cc	2009-01-30 04:01:12 +0000
@@ -40,6 +40,15 @@
   
   switch (arg0_result_type)
   {
+    case DECIMAL_RESULT: 
+      /* 
+       * For doubles supplied, interpret the arg as a string, 
+       * so intentionally fall-through here...
+       * This allows us to accept double parameters like 
+       * 19971231235959.01 and interpret it the way MySQL does:
+       * as a TIMESTAMP-like thing with a microsecond component.
+       * Ugh, but need to keep backwards-compat.
+       */
     case STRING_RESULT:
       {
         char buff[DRIZZLE_MAX_LENGTH_DATETIME_AS_STRING];

=== modified file 'drizzled/temporal_format.cc'
--- drizzled/temporal_format.cc	2009-01-29 19:47:12 +0000
+++ drizzled/temporal_format.cc	2009-01-30 04:01:12 +0000
@@ -52,6 +52,7 @@
 , _minute_part_index(0)
 , _second_part_index(0)
 , _usecond_part_index(0)
+, _nsecond_part_index(0)
 {
   /* Make sure we've got no junk in the match_vector. */
   memset(_match_vector, 0, sizeof(_match_vector));
@@ -157,20 +158,46 @@
   {
     size_t usecond_start= _match_vector[_usecond_part_index];
     size_t usecond_len= _match_vector[_usecond_part_index + 1] - _match_vector[_usecond_part_index];
-    to->_useconds= atoi(copy_data.substr(usecond_start, usecond_len).c_str());
+    /* 
+     * For microseconds, which are millionth of 1 second, 
+     * we must ensure that we produce a correct result, 
+     * even if < 6 places were specified.  For instance, if we get .1, 
+     * we must produce 100000. .11 should produce 110000, etc.
+     */
+    uint32_t multiplier= 1;
+    int32_t x= usecond_len;
+    while (x < 6)
+    {
+      multiplier*= 10;
+      ++x;
+    }
+    to->_useconds= atoi(copy_data.substr(usecond_start, usecond_len).c_str()) * multiplier;
   }
   if (_nsecond_part_index > 1)
   {
     size_t nsecond_start= _match_vector[_nsecond_part_index];
     size_t nsecond_len= _match_vector[_nsecond_part_index + 1] - _match_vector[_nsecond_part_index];
-    to->_nseconds= atoi(copy_data.substr(nsecond_start, nsecond_len).c_str());
+    /* 
+     * For nanoseconds, which are 1 billionth of a second, 
+     * we must ensure that we produce a correct result, 
+     * even if < 9 places were specified.  For instance, if we get .1, 
+     * we must produce 100000000. .11 should produce 110000000, etc.
+     */
+    uint32_t multiplier= 1;
+    int32_t x= nsecond_len;
+    while (x < 9)
+    {
+      multiplier*= 10;
+      ++x;
+    }
+    to->_nseconds= atoi(copy_data.substr(nsecond_start, nsecond_len).c_str()) * multiplier;
   }
   return true;
 }
 
 } /* end namespace drizzled */
 
-#define COUNT_KNOWN_FORMATS 13
+#define COUNT_KNOWN_FORMATS 14
 
 struct temporal_format_args
 {
@@ -199,19 +226,20 @@
  */
 static struct temporal_format_args __format_args[COUNT_KNOWN_FORMATS]= 
 {
-  {"^(\\d{4})(\\d{2})(\\d{2})(\\d{2})(\\d{2})(\\d{2})\\.(\\d{6})$", 1, 2, 3, 4, 5, 6, 7, 0} /* YYYYMMDDHHmmSS.uuuuuu */
+  {"^(\\d{4})(\\d{2})(\\d{2})(\\d{2})(\\d{2})(\\d{2})\\.(\\d{1,6})$", 1, 2, 3, 4, 5, 6, 7, 0} /* YYYYMMDDHHmmSS.uuuuuu */
 , {"^(\\d{4})(\\d{2})(\\d{2})(\\d{2})(\\d{2})(\\d{2})$", 1, 2, 3, 4, 5, 6, 0, 0} /* YYYYMMDDHHmmSS */
-, {"^(\\d{4})[-/.](\\d{1,2})[-/.](\\d{1,2})[T|\\s+](\\d{2}):(\\d{2}):(\\d{2})\\.(\\d{6})$", 1, 2, 3, 4, 5, 6, 7, 0} /* YYYY[/-.]MM[/-.]DD[T]HH:mm:SS.uuuuuu */
+, {"^(\\d{4})[-/.](\\d{1,2})[-/.](\\d{1,2})[T|\\s+](\\d{2}):(\\d{2}):(\\d{2})\\.(\\d{1,6})$", 1, 2, 3, 4, 5, 6, 7, 0} /* YYYY[/-.]MM[/-.]DD[T]HH:mm:SS.uuuuuu */
 , {"^(\\d{4})[-/.](\\d{1,2})[-/.](\\d{1,2})[T|\\s+](\\d{2}):(\\d{2}):(\\d{2})$", 1, 2, 3, 4, 5, 6, 0, 0} /* YYYY[/-.]MM[/-.]DD[T]HH:mm:SS */
 , {"^(\\d{4})[-/.](\\d{1,2})[-/.](\\d{1,2})$", 1, 2, 3, 0, 0, 0, 0, 0} /* YYYY-MM-DD, YYYY.MM.DD, YYYY/MM/DD */
 , {"^(\\d{4})(\\d{2})(\\d{2})$", 1, 2, 3, 0, 0, 0, 0, 0} /* YYYYMMDD */
 , {"^(\\d{2})[-/.]*(\\d{2})[-/.]*(\\d{4})$", 3, 1, 2, 0, 0, 0, 0, 0} /* MM[-/.]DD[-/.]YYYY (US common format)*/
 , {"^(\\d{2})[-/.]*(\\d{2})[-/.]*(\\d{2})$", 1, 2, 3, 0, 0, 0, 0, 0} /* YY[-/.]MM[-/.]DD */
 , {"^(\\d{2})[-/.]*(\\d{1,2})[-/.]*(\\d{1,2})$", 1, 2, 3, 0, 0, 0, 0, 0} /* YY[-/.][M]M[-/.][D]D */
-, {"^(\\d{2}):*(\\d{2}):*(\\d{2})\\.(\\d{6})$", 0, 0, 0, 1, 2, 3, 4, 0} /* HHmmSS.uuuuuu, HH:mm:SS.uuuuuu */
+, {"^(\\d{2}):*(\\d{2}):*(\\d{2})\\.(\\d{1,6})$", 0, 0, 0, 1, 2, 3, 4, 0} /* HHmmSS.uuuuuu, HH:mm:SS.uuuuuu */
 , {"^(\\d{1,2}):*(\\d{2}):*(\\d{2})$", 0, 0, 0, 1, 2, 3, 0, 0} /* [H]HmmSS, [H]H:mm:SS */
 , {"^(\\d{1,2}):*(\\d{2})$", 0, 0, 0, 0, 1, 2, 0, 0} /* [m]mSS, [m]m:SS */
 , {"^(\\d{1,2})$", 0, 0, 0, 0, 0, 1, 0, 0} /* SS, S */
+, {"^(\\d{1,2})\\.(\\d{1,6})$", 0, 0, 0, 0, 0, 1, 2, 0} /* [S]S.uuuuuu */
 };
 
 std::vector<drizzled::TemporalFormat*> known_datetime_formats;

=== modified file 'tests/r/dayofmonth.result'
--- tests/r/dayofmonth.result	2009-01-28 19:45:25 +0000
+++ tests/r/dayofmonth.result	2009-01-30 04:01:12 +0000
@@ -66,8 +66,9 @@
 SELECT DAYOFMONTH(20090916091528);
 DAYOFMONTH(20090916091528)
 16
-SELECT DAYOFMONTH(20090916091528.000000);
-ERROR HY000: Received an invalid datetime value '20090916091528.000000'.
+SELECT DAYOFMONTH(20090916091528.000001);
+DAYOFMONTH(20090916091528.000001)
+16
 USE test;
 DROP TABLE IF EXISTS t1;
 CREATE TABLE t1 (

=== modified file 'tests/r/dayofyear.result'
--- tests/r/dayofyear.result	2009-01-28 20:02:10 +0000
+++ tests/r/dayofyear.result	2009-01-30 04:01:12 +0000
@@ -69,8 +69,9 @@
 SELECT DAYOFYEAR(20090916091528);
 DAYOFYEAR(20090916091528)
 259
-SELECT DAYOFYEAR(20090916091528.000000);
-ERROR HY000: Received an invalid datetime value '20090916091528.000000'.
+SELECT DAYOFYEAR(20090916091528.000001);
+DAYOFYEAR(20090916091528.000001)
+259
 USE test;
 DROP TABLE IF EXISTS t1;
 CREATE TABLE t1 (

=== modified file 'tests/r/hour.result'
--- tests/r/hour.result	2009-01-29 21:31:20 +0000
+++ tests/r/hour.result	2009-01-30 04:01:12 +0000
@@ -48,6 +48,9 @@
 SELECT HOUR(20081130033015);
 HOUR(20081130033015)
 3
+SELECT HOUR(20081130033015.01);
+HOUR(20081130033015.01)
+3
 SELECT HOUR(231115);
 HOUR(231115)
 23

=== modified file 'tests/r/microsecond.result'
--- tests/r/microsecond.result	2009-01-29 22:00:06 +0000
+++ tests/r/microsecond.result	2009-01-30 04:01:12 +0000
@@ -53,9 +53,42 @@
 SELECT MICROSECOND("20081130033015.123456");
 MICROSECOND("20081130033015.123456")
 123456
+SELECT MICROSECOND("20081130033015.12345");
+MICROSECOND("20081130033015.12345")
+123450
+SELECT MICROSECOND("20081130033015.1234");
+MICROSECOND("20081130033015.1234")
+123400
+SELECT MICROSECOND("20081130033015.123");
+MICROSECOND("20081130033015.123")
+123000
+SELECT MICROSECOND("20081130033015.12");
+MICROSECOND("20081130033015.12")
+120000
+SELECT MICROSECOND("20081130033015.1");
+MICROSECOND("20081130033015.1")
+100000
 SELECT MICROSECOND(20081130033015);
 MICROSECOND(20081130033015)
 0
+SELECT MICROSECOND(20081130033015.123456);
+MICROSECOND(20081130033015.123456)
+123456
+SELECT MICROSECOND(20081130033015.12345);
+MICROSECOND(20081130033015.12345)
+123450
+SELECT MICROSECOND(20081130033015.1234);
+MICROSECOND(20081130033015.1234)
+123400
+SELECT MICROSECOND(20081130033015.123);
+MICROSECOND(20081130033015.123)
+123000
+SELECT MICROSECOND(20081130033015.12);
+MICROSECOND(20081130033015.12)
+120000
+SELECT MICROSECOND(20081130033015.1);
+MICROSECOND(20081130033015.1)
+100000
 SELECT MICROSECOND(231115);
 MICROSECOND(231115)
 0

=== modified file 'tests/r/minute.result'
--- tests/r/minute.result	2009-01-29 21:40:38 +0000
+++ tests/r/minute.result	2009-01-30 04:01:12 +0000
@@ -48,6 +48,9 @@
 SELECT MINUTE(20081130033015);
 MINUTE(20081130033015)
 30
+SELECT MINUTE(20081130033015.01);
+MINUTE(20081130033015.01)
+30
 SELECT MINUTE(231115);
 MINUTE(231115)
 11

=== modified file 'tests/r/month.result'
--- tests/r/month.result	2009-01-28 18:31:33 +0000
+++ tests/r/month.result	2009-01-30 04:01:12 +0000
@@ -66,8 +66,9 @@
 SELECT MONTH(20090916091528);
 MONTH(20090916091528)
 9
-SELECT MONTH(20090916091528.000000);
-ERROR HY000: Received an invalid datetime value '20090916091528.000000'.
+SELECT MONTH(20090916091528.000001);
+MONTH(20090916091528.000001)
+9
 USE test;
 DROP TABLE IF EXISTS t1;
 CREATE TABLE t1 (

=== modified file 'tests/r/second.result'
--- tests/r/second.result	2009-01-29 19:47:12 +0000
+++ tests/r/second.result	2009-01-30 04:01:12 +0000
@@ -48,6 +48,9 @@
 SELECT SECOND(20081130033015);
 SECOND(20081130033015)
 15
+SELECT SECOND(20081130033015.01);
+SECOND(20081130033015.01)
+15
 SELECT SECOND(231115);
 SECOND(231115)
 15

=== modified file 'tests/r/year.result'
--- tests/r/year.result	2009-01-28 02:39:29 +0000
+++ tests/r/year.result	2009-01-30 04:01:12 +0000
@@ -72,8 +72,9 @@
 SELECT YEAR(20090916091528);
 YEAR(20090916091528)
 2009
-SELECT YEAR(20090916091528.000000);
-ERROR HY000: Received an invalid datetime value '20090916091528.000000'.
+SELECT YEAR(20090916091528.000001);
+YEAR(20090916091528.000001)
+2009
 USE test;
 DROP TABLE IF EXISTS t1;
 CREATE TABLE t1 (

=== modified file 'tests/t/dayofmonth.test'
--- tests/t/dayofmonth.test	2009-01-28 19:45:25 +0000
+++ tests/t/dayofmonth.test	2009-01-30 04:01:12 +0000
@@ -75,8 +75,7 @@
 SELECT DAYOFMONTH('09-9-2');
 SELECT DAYOFMONTH(20090916);
 SELECT DAYOFMONTH(20090916091528);
---error 1686 # Don't yet support DOUBLE -> DATETIME.
-SELECT DAYOFMONTH(20090916091528.000000);
+SELECT DAYOFMONTH(20090916091528.000001);
 
 # Now test field values of different types
 

=== modified file 'tests/t/dayofyear.test'
--- tests/t/dayofyear.test	2009-01-28 20:02:10 +0000
+++ tests/t/dayofyear.test	2009-01-30 04:01:12 +0000
@@ -78,8 +78,7 @@
 SELECT DAYOFYEAR('09-9-2');
 SELECT DAYOFYEAR(20090916);
 SELECT DAYOFYEAR(20090916091528);
---error 1686 # Don't yet support DOUBLE -> DATETIME.
-SELECT DAYOFYEAR(20090916091528.000000);
+SELECT DAYOFYEAR(20090916091528.000001);
 
 # Now test field values of different types
 

=== modified file 'tests/t/hour.test'
--- tests/t/hour.test	2009-01-29 21:31:20 +0000
+++ tests/t/hour.test	2009-01-30 04:01:12 +0000
@@ -81,6 +81,9 @@
 # A good datetime, interpreted int->string, should output 3
 SELECT HOUR(20081130033015);
 
+# A good datetime with subsecond component, interpreted int->string, should output 3
+SELECT HOUR(20081130033015.01);
+
 # A good time (according to MySQL, not Jay Pipes...), should output 23
 SELECT HOUR(231115);
 

=== modified file 'tests/t/microsecond.test'
--- tests/t/microsecond.test	2009-01-29 22:00:06 +0000
+++ tests/t/microsecond.test	2009-01-30 04:01:12 +0000
@@ -86,9 +86,42 @@
 # A good datetime, should output 123456
 SELECT MICROSECOND("20081130033015.123456");
 
+# A good datetime, should output 123450
+SELECT MICROSECOND("20081130033015.12345");
+
+# A good datetime, should output 123400
+SELECT MICROSECOND("20081130033015.1234");
+
+# A good datetime, should output 123000
+SELECT MICROSECOND("20081130033015.123");
+
+# A good datetime, should output 120000
+SELECT MICROSECOND("20081130033015.12");
+
+# A good datetime, should output 100000
+SELECT MICROSECOND("20081130033015.1");
+
 # A good datetime, interpreted int->string, should output 0 since no sub-second component
 SELECT MICROSECOND(20081130033015);
 
+# A good datetime, interpreted int->string, should output 123456
+SELECT MICROSECOND(20081130033015.123456);
+
+# A good datetime, interpreted int->string, should output 123450
+SELECT MICROSECOND(20081130033015.12345);
+
+# A good datetime, interpreted int->string, should output 123400
+SELECT MICROSECOND(20081130033015.1234);
+
+# A good datetime, interpreted int->string, should output 123000
+SELECT MICROSECOND(20081130033015.123);
+
+# A good datetime, interpreted int->string, should output 120000
+SELECT MICROSECOND(20081130033015.12);
+
+# A good datetime, interpreted int->string, should output 100000
+SELECT MICROSECOND(20081130033015.1);
+
 # A good time (according to MySQL, not Jay Pipes...), should output 0 since no sub-second component
 SELECT MICROSECOND(231115);
 

=== modified file 'tests/t/minute.test'
--- tests/t/minute.test	2009-01-29 21:40:38 +0000
+++ tests/t/minute.test	2009-01-30 04:01:12 +0000
@@ -81,6 +81,9 @@
 # A good datetime, interpreted int->string, should output 30
 SELECT MINUTE(20081130033015);
 
+# A good datetime with subsecond component, interpreted int->string, should output 30
+SELECT MINUTE(20081130033015.01);
+
 # A good time (according to MySQL, not Jay Pipes...), should output 11
 SELECT MINUTE(231115);
 

=== modified file 'tests/t/month.test'
--- tests/t/month.test	2009-01-28 18:31:33 +0000
+++ tests/t/month.test	2009-01-30 04:01:12 +0000
@@ -79,8 +79,7 @@
 SELECT MONTH('09-9-2');
 SELECT MONTH(20090916);
 SELECT MONTH(20090916091528);
---error 1686 # Don't yet support DOUBLE -> DATETIME.
-SELECT MONTH(20090916091528.000000);
+SELECT MONTH(20090916091528.000001);
 
 # Now test field values of different types
 

=== modified file 'tests/t/second.test'
--- tests/t/second.test	2009-01-29 21:31:20 +0000
+++ tests/t/second.test	2009-01-30 04:01:12 +0000
@@ -81,6 +81,9 @@
 # A good datetime, interpreted int->string, should output 15
 SELECT SECOND(20081130033015);
 
+# A good datetime with subsecond component, interpreted int->string, should output 15
+SELECT SECOND(20081130033015.01);
+
 # A good time (according to MySQL, not Jay Pipes...), should output 15
 SELECT SECOND(231115);
 

=== modified file 'tests/t/year.test'
--- tests/t/year.test	2009-01-28 18:31:33 +0000
+++ tests/t/year.test	2009-01-30 04:01:12 +0000
@@ -85,8 +85,7 @@
 SELECT YEAR('09-9-2');
 SELECT YEAR(20090916);
 SELECT YEAR(20090916091528);
---error 1686 # Don't yet support DOUBLE -> DATETIME.
-SELECT YEAR(20090916091528.000000);
+SELECT YEAR(20090916091528.000001);
 
 # Now test field values of different types
 

